VERSION 2.00
Begin Form MIDIForm 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "One Note MIDI Example"
   ClientHeight    =   1905
   ClientLeft      =   1485
   ClientTop       =   2340
   ClientWidth     =   5025
   ClipControls    =   0   'False
   Height          =   2595
   Icon            =   ONENOTE.FRX:0000
   Left            =   1425
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1905
   ScaleWidth      =   5025
   Top             =   1710
   Width           =   5145
   Begin Frame FrameMIDINote 
      BackColor       =   &H00C0C0C0&
      Caption         =   "MIDI Note"
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   1815
      Left            =   3960
      TabIndex        =   6
      Top             =   0
      Width           =   1035
      Begin VScrollBar VScrollMIDINote 
         Height          =   1425
         LargeChange     =   10
         Left            =   180
         Max             =   0
         Min             =   127
         TabIndex        =   7
         Top             =   300
         Value           =   64
         Width           =   315
      End
      Begin Label LabelMIDINote 
         Alignment       =   2  'Center
         BackColor       =   &H00C0C0C0&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "64"
         FontBold        =   0   'False
         FontItalic      =   0   'False
         FontName        =   "Small Fonts"
         FontSize        =   6.75
         FontStrikethru  =   0   'False
         FontUnderline   =   0   'False
         Height          =   225
         Left            =   540
         TabIndex        =   8
         Top             =   300
         Width           =   435
      End
   End
   Begin CommandButton CmdPlayMIDI 
      Caption         =   "Play MIDI"
      Height          =   675
      Left            =   60
      TabIndex        =   5
      Top             =   1140
      Width           =   3855
   End
   Begin Frame FrameMIDISettings 
      BackColor       =   &H00C0C0C0&
      Caption         =   "MIDI Settings"
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   1065
      Left            =   60
      TabIndex        =   0
      Top             =   0
      Width           =   3855
      Begin Frame FrameMidiChannelOut 
         BackColor       =   &H00C0C0C0&
         Caption         =   "MIDI Channel"
         FontBold        =   0   'False
         FontItalic      =   0   'False
         FontName        =   "MS Sans Serif"
         FontSize        =   8.25
         FontStrikethru  =   0   'False
         FontUnderline   =   0   'False
         Height          =   645
         Left            =   1980
         TabIndex        =   3
         Top             =   300
         Width           =   1815
         Begin HScrollBar HScrollMIDIChannel 
            Height          =   285
            LargeChange     =   2
            Left            =   120
            Max             =   15
            TabIndex        =   4
            Top             =   270
            Value           =   1
            Width           =   1590
         End
      End
      Begin Frame FrameVolume 
         BackColor       =   &H00C0C0C0&
         Caption         =   "Volume"
         FontBold        =   0   'False
         FontItalic      =   0   'False
         FontName        =   "MS Sans Serif"
         FontSize        =   8.25
         FontStrikethru  =   0   'False
         FontUnderline   =   0   'False
         Height          =   645
         Left            =   120
         TabIndex        =   1
         Top             =   300
         Width           =   1755
         Begin HScrollBar HScrollVolume 
            Height          =   255
            LargeChange     =   10
            Left            =   120
            Max             =   127
            TabIndex        =   2
            Top             =   300
            Value           =   50
            Width           =   1515
         End
      End
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuHelp 
      Caption         =   "&Help"
      Begin Menu mnuHelpAbout 
         Caption         =   "&About"
      End
   End
End
Option Explicit

' If you're ready for a bit more advanced MIDI example program, check out
' my VB MIDI Piano example.  It should be available wherever "One Note MIDI"
' was located.  It's fun...it's FREE!

' If you really want to do more neat stuff with MIDI and VB, you
' should check out MIDI CoolTools.

' I've been developing MIDI applications in Visual Basic since VB 1.0
' and Windows 3.0.  After years of limitations and more limitations with
' VB and MIDI, it seemed like a good idea to take my experience and
' really make it possible to write MIDI apps in VB.

'...after months of working with two VB custom control experts, we
' have MIDI CoolTools...

' MIDI CoolTools is a set of MIDI custom controls for Visual Basic.  MIDI
' CoolTools gives you full access to MIDI from inside of Visual Basic.

' The following controls make up MIDI CoolTools:

' MIDI IN Custom Control: The MIDI IN Custom Control automatically detects
' the available MIDI IN ports and allows you to select the port you wish to
' use. As MIDI events are received through the selected MIDI IN port, each
' MIDI event receives a high resolution time stamp.  A built in message
' queue allows Long and Short MIDI messages to be received.

'*   Receive MIDI messages from external MIDI devices
'*   Messages can be retrieved using events or polling
'*   Messages are time-stamped with millisecond accuracy
'*   Built in internal queuing mechanism
'*   Buffer for receiving system exclusive messages
'*   Automatically detects the available MIDI IN ports


' MIDI OUT Custom Control: The MIDI OUT Custom Control automatically detects
' the available MIDI OUT ports and allows you to select a MIDI OUT port to
' use.  This control allows MIDI messages to be sent directly to the MIDI
' OUT port and also allows MIDI messages to be queued for playback at the
' appropriate time.

'*   Complete control over the contents and timing of MIDI messages.
'*   Queue as many messages as you like (within the constraints of available
'    memory)
'*   Queue messages prior to starting output and then add more as the output
'    proceeds
'*   Messages are scheduled for transmission at a time you specify
'*   Control timing has millisecond resolution
'*   Automatically detects the available MIDI OUT ports
'*   Complete support for system exclusive messages
'*   Timer event provides a high-resolution timer
'*   Automatically detect whether or not the current device supports patch
'    caching
'*   Automatically detect and control current device volume
'*   Adjust tempo playback rate in realtime


' Standard MIDI File Custom Control: Read and write Standard MIDI files.
' This custom control allows you to read any Standard MIDI file into a data
' structure with full access to the MIDI data.  Open MIDI files, close MIDI
' files, create new MIDI files, save changes, insert new MIDI message,
' modify MIDI messages and delete MIDI message.  Supports MIDI file
' type 0 & 1.

'*   Provides the VB programmer with an easy way to read and write Standard
'    MIDI files
'*   Both formats 0 (single track) and 1 (multiple-tracks) are supported
'*   Modify existing MIDI files or create entirely new ones from scratch
'*   Complete control over and access to every type of MIDI message
'*   Insert, delete and modify tracks and messages at anytime
'*   Action property to open, close, create and save the data to the current
'    file
'*   Action property to insert, change and delete the current message
'*   Insert new tracks or delete tracks
'*   Complete support for system exclusive messages


' Knob Custom Control: Four different knob styles to choose from makes the
' knob custom control very versatile.  A collection of flexible tickmark
' properties greatly enhances the knob's usefulness for developing
' commercial applications. Easily control knob color with five different
' color properties.  Over thirty knob properties are at your control tips!

'*   Normal, raised, lowered and textured knob styles
'*   User definable number of tickmarks with captions
'*   Full control of tick caption fonts
'*   Control knob color, tick color, tick caption color and background
'    color
'*   Bevel properties for 3D style look
'*   Link to other MIDI CoolTools custom control without writing any code


' VU Indicator Custom Control: Horizontal and vertical Indicator custom
' controls allow you to quickly create professional VU segmented meters.
' This custom control was specially designed to allow you to simply create
' state-of-the-art graphic LED VU meters.  Three separate colored segment
' sections can be defined with up to twenty LED segments per section.  A
' comprehensive set of 3D bevel properties allows for flexible visual
' control.

'*   Horizontal and vertical indicator (otherwise known as a VU meter).
'*   Tie directly to other controls in this package using SmartLink
'    properties
'*   Display information (such as volume, balance, etc.)
'*   A comprehensive set of 3D bevel properties allows for flexible visual
'    control.
'*   Three separate colored segment sections can be defined


' Fader/Slider Custom Control: Easily create a cool looking audio mixer with
' the Fader/Slider horizontal and vertical custom controls.  A complete set
' of bevel properties allows you to quickly get that beautiful 3D look.
' Four different thumb styles adds to the flexibility of this control.
' Tickmark properties round out this control's great features.

'*   Complete set of bevel properties
'*   Slider control is similar in function to a scroll bar, but looks
'    cooler
'*   Pro audio mixer style thumbs
'*   Up, down, left and right thumb properties
'*   Tick properties with tickcolor, tickcount, tickwidth, ticklength & gap
'    control
'*   Horizontal and vertical slider custom controls
'*   Control of the 3-D style of the track


' MIDI CoolTools includes all of these custom controls.  Also included
' is sample code and a printed reference manual.  Standard Retail
' Price is $99 for MIDI CoolTools, but through December 31, 1994 we're
' offering MIDI CoolTools for $59 + $4 s/h.  $8 s/h for foreign orders.

' You can order with VISA/MC or Check in US funds:

' MIDI CoolTools
' Artic Software
' PO Box 28
' Waterford, WI  53185-0028

' Fax orders: 414-534-7809
' Voice : 414-534-4309
' Compuserve 75410,2203


' Thanks for trying out my MIDI One Note Example.

' If this example was useful or if you have other VB MIDI questions
' just let me know...

'                    - Arthur Edstrom, Artic Software


Sub CmdPlayMIDI_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    '
    'Structure the MIDI event and send it
    '
    'Note: Look at the ONENOTE.BAS constants that I have defined.
    'Note: You can easily use these to send other MIDI messages.
    '
    midiMessageOut = NOTE_ON + midiChannelOut
    midiData1 = VScrollMIDINote.Value
    midiData2 = midiVolume(midiChannelOut)
    SendMidiOut
End Sub

Sub CmdPlayMIDI_MouseUp (Button As Integer, Shift As Integer, X As Single, Y As Single)
    '
    'Structure the MIDI event and send it - in this MouseUp event,
    'we are sending a NOTE_ON with 0 velocity.  This is a very
    'common way to turn MIDI notes off.  You could send a NOTE_OFF event,
    'but not all equipment supports the NOTE_OFF.
    '
    'Note: Look at the ONENOTE.BAS constants that I have defined.
    'Note: You can easily use these to send other MIDI messages.
    '
    midiMessageOut = NOTE_ON + midiChannelOut
    midiData1 = VScrollMIDINote.Value
    midiData2 = 0
    SendMidiOut
End Sub

Sub Form_Load ()
    Screen.MousePointer = HOURGLASS
    
    ' Center the AboutBox on the screen
    '
    Move (Screen.Width - Width) \ 2, (Screen.Height - Height) \ 2
    
    ' Open Midi Driver
    MidiOutOpenPort
    
    HScrollMIDIChannel.Value = 0
    HScrollVolume.Value = 100
    Screen.MousePointer = DEFAULT
End Sub

Sub Form_Unload (Cancel As Integer)
    Dim X As Integer

    'Close the MIDIOut Port
    X = MidiOutClose(hMidiOut)

    End
End Sub

Sub HScrollMIDIChannel_Change ()
    ' Change Midi Channel to HScrollMIDIChannelvalue
    midiChannelOut = HScrollMIDIChannel.Value

    ' Display new channel
    FrameMidiChannelOut.Caption = "MIDI Channel " & Str$(midiChannelOut + 1)

    ' Sets the Volume for the current Midi Channel Out
    HScrollVolume.Value = midiVolume(midiChannelOut)
End Sub

Sub HScrollVolume_Change ()
    '
    'Set the velocity of the NOTE_ON you are going to send
    '
    midiVolume(midiChannelOut) = HScrollVolume.Value
    FrameVolume.Caption = "Volume " & Str$(midiVolume(midiChannelOut))

    '
    'They are many different ways to adjust volume of MIDI data
    'from inside of Windows.  Here's a few...
    '
    'This one is the velocity method.  There are MIDI Channel Volume
    'controller events that can be send.  MIDI Devices usually have a Master
    'Volume, patch volumes, channel volumes and sometimes other volumes that
    'can be adjusted.  Most sound cards have a driver volume for MIDI
    'and a master volume.  And don't forget about that MIDI Mapper,
    'where you can adjust patch volumes.
End Sub

Sub mnuFileExit_Click ()
    Dim X As Integer

    'Close the MIDIOut Port
    X = MidiOutClose(hMidiOut)

    End
End Sub

Sub mnuHelpAbout_Click ()
    AboutBox1.Show Modal
End Sub

Sub VScrollMIDINote_Change ()
    LabelMIDINote.Caption = Str(VScrollMIDINote.Value)
End Sub

Sub VScrollMIDINote_Scroll ()
    LabelMIDINote.Caption = Str(VScrollMIDINote.Value)
End Sub

